#include <Wire.h>

byte deviceAddress = 0x10;  // The address of the TF-Luna device is 0x10
unsigned char buf1[] = {0x5A,0x05,0x00,0x01,0x60};
void setup() {
  Wire.begin();             // The I2C bus communication starts
  Serial.begin(115200);     // Example Set the baud rate of the serial port to 115200
}

void loop() {
  Wire.beginTransmission(deviceAddress);                    // The I2C data transmission starts
  Wire.write(buf1,5);                                       // Send command
  Wire.endTransmission();                                   // The I2C data transfer is complete

  Wire.requestFrom((uint8_t)deviceAddress, (uint8_t)7);     // Read 7 bytes of data 

  if (Wire.available() == 7) {                              // 7 bytes of data are available
    byte data[7];
    for (int i = 0; i < 7; i++) {
      data[i] = Wire.read();                                // Read data into an array
    }

    unsigned int distance = (data[3] << 8) | data[2];       // DistanceValue
    unsigned int signalStrength = (data[5] << 8) | data[4]; // signal strength

    Serial.print("Distance: ");
    Serial.print(distance);
    Serial.print(" cm  \n");

    Serial.print("Signal Strength: ");
    Serial.print(signalStrength);
    Serial.print("\n");
  }
  delay(10);               

}